(function(){
	tinymce.create("tinymce.plugins.exp_cta", {
		init: function(editor, url) {
			editor.addButton("exp_cta", {
				title: "CTA (Call to Action)",
				icon: "icon exp_cta exp-mce-icon dashicons-image-filter",
				onclick: function(){
					editor.windowManager.open({
						title: "CTA (Call to Action)",
						bodyType: "tabpanel",
						body: [
							{
								title: "General",
								type: "form",
								items:[
								
		
									{type: "selectbox", name: "cta", label: "CTA", tooltip: "", options:["1","2","3","4","5","6","7","8","9"] },
									{type: "selectbox", name: "tag_type", label: "Tag Type", tooltip: "", options:["button","link"] },
									{type: "textbox", name: "href", label: "href", tooltip: "" },
									{type: "textbox", name: "id", label: "CSS ID", tooltip: "" }		
								
								]
							},
							{
								title: "About",
								type: "form",
								items:[
									{type: "panel",html:"<h4 style='font-size:24px;font-weight:600;'>CTA (Call to Action) v.1.0.1</h4><br/><p style='font-size:12px;'>Created by <a style='font-size:12px;cursor:pointer;font-weight:600;' href='https://everxp.com'>1178 Team</a></p>"},
								]
							}
						],
						onsubmit: function(e){
							var shortcode = "";
							shortcode += "[exp_cta ";
							if(e.data.cta == ""){
								e.data.cta = "1";
							}
							shortcode +="cta=\""  + e.data.cta + "\" " ;
							if(e.data.tag_type == ""){
								e.data.tag_type = "button";
							}
							shortcode +="tag_type=\""  + e.data.tag_type + "\" " ;
							if(e.data.href == ""){
								e.data.href = "";
							}
							shortcode +="href=\""  + e.data.href + "\" " ;
							if(e.data.id == ""){
								e.data.id = "";
							}
							shortcode +="id=\""  + e.data.id + "\" " ;
							shortcode += "]";
							shortcode += "[/exp_cta]";
							editor.insertContent(shortcode);
						}
					});
				}
			});
		},
		createControl: function(n, cm) {
			return null;
		},
		getInfo: function() {
			return {
				longname: "EXP - CTA (Call to Action)",
				author: "1178 Team",
				authorurl: "https://everxp.com",
				infourl: "https://everxp.com",
				version: "1.0.1"
			};
		}
	});
	tinymce.PluginManager.add("exp_cta", tinymce.plugins.exp_cta);
})();
