<?php

/**
 * @author 1178 Team
 * @package Elementor_cta_Widget
 * @license GNU General Public License v2 or later
**/


defined("EXP_EXEC") or die("Silent is golden");


/**
 * Elementor_cta_Widget
**/
class Elementor_cta_Widget extends \Elementor\Widget_Base {
	
	/**
	* Get widget name.
	* Retrieve widget name.
	* @since 1.0.0
	* @access public
	* @return string Widget name.
	*/
	public function get_name(){
		return "cta_widget";
	}
	
	
	/**
	* Get widget title.
	* Retrieve widget title.
	* @since 1.0.0
	* @access public
	* @return string Widget title.
	*/
	public function get_title(){
		return esc_html__("EXP CTAs", "everxp");
	}
	
	
	/**
	* Get widget icon.
	* Retrieve widget icon.
	* @since 1.0.0
	* @access public
	* @return string Widget icon.
	*/
	public function get_icon(){
		return "eicon-button";
	}
	
	
	/**
	* Get custom help URL.
	* Retrieve a URL where the user can get more information about the widget.
	* @since 1.0.0
	* @access public
	* @return string Widget help URL.
	*/
	public function get_custom_help_url() {
		return "https://everxp.com";
	}
	
	
	/**
	* Get widget categories.
	* Retrieve the list of categories the widget belongs to.
	* @since 1.0.0
	* @access public
	* @return array Widget categories.
	*/
	public function get_categories(){
		return ["basic"];
	}
	
	
	/**
	* Get widget keywords.
	* Retrieve the list of keywords the widget belongs to.
	* @since 1.0.0
	* @access public
	* @return array Widget keywords.
	*/
	public function get_keywords() {
		return ["gamification","analytics","quotes","micro-copies","langauge","language"];
	}
	
	
	/**
	* Register widget controls.
	* Add input fields to allow the user to customize the widget settings.
	* @since 1.0.0
	* @access protected
	*/
	protected function register_controls(){
		
		// TODO: CUSTOM-CODE --|-- register_controls
		
		// start-section
		$this->start_controls_section(
			"exp_start_section",
			[
				"label" => esc_html__("tab1", "everxp"),
				"tab" => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		
		// tag-type
		$this->add_control(
			"exp_tag_type",
			[
				"label" => esc_html__("Tag Type", "everxp"),
				"type" => \Elementor\Controls_Manager::SELECT,
				"options" => [
					"button" => "button",
					"link" => "link",
				],
				"default" => "button",
			]
		);
		
		// href
		$this->add_control(
			"exp_href",
			[
				"label" => esc_html__("href", "everxp"),
				"type" => \Elementor\Controls_Manager::TEXT,
				"placeholder" => esc_html__("", "everxp"),
				"input_type" => "url",
				"default" => "",
			]
		);
		
		// id
		$this->add_control(
			"exp_id",
			[
				"label" => esc_html__("CSS ID", "everxp"),
				"type" => \Elementor\Controls_Manager::TEXT,
				"placeholder" => esc_html__("", "everxp"),
				"input_type" => "text",
				"default" => "",
			]
		);
		
		// cta
		$this->add_control(
			"exp_cta",
			[
				"label" => esc_html__("CTA", "everxp"),
				"type" => \Elementor\Controls_Manager::SELECT,
				"options" => [
					"1" => "1",
					"2" => "2",
					"3" => "3",
					"4" => "4",
					"5" => "5",
					"6" => "6",
					"7" => "7",
					"8" => "8",
					"9" => "9",
				],
				"default" => "1",
			]
		);
		
		// end1
		$this->end_controls_section();
		$this->end_controls_section();
		
	}
		
		
	/**
	* Render widget output on the frontend.
	* 
	* @since 1.0.0
	* @access protected
	*/
	protected function render(){
		$settings = $this->get_settings_for_display();
		$exp_tag_type = $settings["exp_tag_type"] ;
		$exp_href = $settings["exp_href"] ;
		$exp_id = $settings["exp_id"] ;
		$exp_cta = $settings["exp_cta"] ;
		/** custom-code **/
		// form
$options = get_option("exp_api_settings_setting");
$attribute_tag_type = $settings['exp_tag_type']; 
$attribute_cta = $settings['exp_cta']; 
$attribute_href = $settings['exp_href']; 
$attribute_id = $settings['exp_id']; 
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/cta?api_key=".$options['exp_api_key']."&cta=".$attribute_cta."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	if ($attribute_tag_type = $atts["tag_type"] == "button") {
		echo "<a href='".$attribute_href."' id='".$attribute_id."'>".$response['heading']."</a>";
	} else {
		echo "<input type='button' onclick='location.href=`".$attribute_href."`;' id='".$attribute_id."' value='".$response['heading']."'>";	
	}
}
		
		
	}
	
	
}
//EOF


