<?php

/**
 * @author 1178 Team
 * @package Elementor_quotes_Widget
 * @license GNU General Public License v2 or later
**/


defined("EXP_EXEC") or die("Silent is golden");


/**
 * Elementor_quotes_Widget
**/
class Elementor_quotes_Widget extends \Elementor\Widget_Base {
	
	/**
	* Get widget name.
	* Retrieve widget name.
	* @since 1.0.0
	* @access public
	* @return string Widget name.
	*/
	public function get_name(){
		return "quotes_widget";
	}
	
	
	/**
	* Get widget title.
	* Retrieve widget title.
	* @since 1.0.0
	* @access public
	* @return string Widget title.
	*/
	public function get_title(){
		return esc_html__("EXP Quotes", "everxp");
	}
	
	
	/**
	* Get widget icon.
	* Retrieve widget icon.
	* @since 1.0.0
	* @access public
	* @return string Widget icon.
	*/
	public function get_icon(){
		return "eicon-blockquote";
	}
	
	
	/**
	* Get custom help URL.
	* Retrieve a URL where the user can get more information about the widget.
	* @since 1.0.0
	* @access public
	* @return string Widget help URL.
	*/
	public function get_custom_help_url() {
		return "https://everxp.com";
	}
	
	
	/**
	* Get widget categories.
	* Retrieve the list of categories the widget belongs to.
	* @since 1.0.0
	* @access public
	* @return array Widget categories.
	*/
	public function get_categories(){
		return ["basic"];
	}
	
	
	/**
	* Get widget keywords.
	* Retrieve the list of keywords the widget belongs to.
	* @since 1.0.0
	* @access public
	* @return array Widget keywords.
	*/
	public function get_keywords() {
		return ["gamification","analytics","quotes","micro-copies","langauge","language"];
	}
	
	
	/**
	* Register widget controls.
	* Add input fields to allow the user to customize the widget settings.
	* @since 1.0.0
	* @access protected
	*/
	protected function register_controls(){
		
		// TODO: CUSTOM-CODE --|-- register_controls
		
		// start-section
		$this->start_controls_section(
			"exp_start_section",
			[
				"label" => esc_html__("tab1", "everxp"),
				"tab" => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		
		// color
		$this->add_control(
			"exp_color",
			[
				"label" => esc_html__("Color", "everxp"),
				"type" => \Elementor\Controls_Manager::COLOR,
				"default" => "#000000",
			]
		);
		
		// tag-type
		$this->add_control(
			"exp_tag_type",
			[
				"label" => esc_html__("Tag Type", "everxp"),
				"type" => \Elementor\Controls_Manager::SELECT,
				"options" => [
					"p" => "p",
					"h1" => "h1",
					"h2" => "h2",
					"h3" => "h3",
					"h4" => "h4",
					"span" => "span",
				],
				"default" => "p",
			]
		);
		
		// quote
		$this->add_control(
			"exp_quote",
			[
				"label" => esc_html__("Quote", "everxp"),
				"type" => \Elementor\Controls_Manager::SELECT,
				"options" => [
					"alone" => "Alone",
					"attitude" => "Attitude",
					"best_life" => "Best Life",
					"fictional" => "Fictional",
					"characters" => "Characters",
					"friendship" => "Friendship",
					"happiness" => "Happiness",
					"inspirational" => "inspirational",
					"leadership" => "Leadership",
					"life" => "Life",
					"love" => "Love",
					"motivational" => "Motivational",
					"nature" => "Nature",
					"reading" => "Reading",
					"relationship" => "Relationship",
					"smile" => "Smile",
					"strength" => "Strength",
					"success" => "Success",
					"time" => "Time",
					"trust" => "Trust",
					"wisdom" => "Wisdom",
					"woman" => "Woman",
				],
				"default" => "wisdom",
			]
		);
		
		// end1
		$this->end_controls_section();
		$this->end_controls_section();
		
	}
		
		
	/**
	* Render widget output on the frontend.
	* 
	* @since 1.0.0
	* @access protected
	*/
	protected function render(){
		$settings = $this->get_settings_for_display();
		$exp_color = $settings["exp_color"] ;
		$exp_tag_type = $settings["exp_tag_type"] ;
		$exp_quote = $settings["exp_quote"] ;
		/** custom-code **/
		// form
$options = get_option("exp_api_settings_setting");
$attribute_quote = $settings['exp_quote'];
$attribute_color = $settings['exp_color'];
$attribute_tag_type = $settings['exp_tag_type']; 

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/quote?api_key=".$options['exp_api_key']."&quote=".$attribute_quote."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	echo "<".$attribute_tag_type." style='color: ".$attribute_color.";'>".$response['heading']."</".$attribute_tag_type.">";
}
		
		
	}
	
	
}
//EOF


