<?php

/**
 * @author 1178 Team
 * @package ExpShortCodes
 * @license GNU General Public License v2 or later
**/


defined("EXP_EXEC") or die("Silent is golden");

/**
 * ExpShortCodes
**/
class ExpShortCodes{


	/**
	 * ExpShortCodes:__construct()
	**/
	function __construct()
	{
		// exp_cta
		add_action("init",array($this,"expCta"));
		add_action("init",array($this,"expCtaTinymce"));
		
		// exp_humanitarian
		add_action("init",array($this,"expHumanitarian"));
		add_action("init",array($this,"expHumanitarianTinymce"));
		
		// exp_patterns
		add_action("init",array($this,"expPatterns"));
		add_action("init",array($this,"expPatternsTinymce"));
		
		// exp_quotes
		add_action("init",array($this,"expQuotes"));
		add_action("init",array($this,"expQuotesTinymce"));
		
		// exp_times
		add_action("init",array($this,"expTimes"));
		add_action("init",array($this,"expTimesTinymce"));
		
	}
	
	
	// TODO: LAYOUT FOR `CTA`
	/**
	 * ExpShortCodes:expCta()
	**/
	function expCta(){
		add_shortcode("exp_cta", array($this, "expCtaShortcode"));
	}
	
	
	/**
	 * ExpShortCodes:expCtaShortcode($atts, $content, $tag)
	**/
	function expCtaShortcode($atts, $content, $tag){
			// shortcode option/attributes
		$atts = shortcode_atts(
			array(
				"cta" => "1",
				"tag_type" => "button",
				"href" => "",
				"id" => "",
			), $atts, $tag);
		
		
		// CUSTOM-CODE
$options = get_option("exp_api_settings_setting");
$attribute_tag_type = $atts["tag_type"]; 
$attribute_cta = $atts["cta"]; 
$attribute_href = $atts["href"]; 
$attribute_id = $atts["id"]; 
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/cta?api_key=".$options['exp_api_key']."&cta=".$attribute_cta."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	if ($attribute_tag_type = $atts["tag_type"] == "button") {
		echo "<a href='".$attribute_href."' id='".$attribute_id."'>".$response['heading']."</a>";
	} else {
		echo "<input type='button' onclick='location.href=`".$attribute_href."`;' id='".$attribute_id."' value='".$response['heading']."'>";	
	}
}
		
		
		
		return $content;
	}
	
	
	/**
	 * ExpShortCodes:expCtaTinymce()
	**/
	function expCtaTinymce(){
		add_filter("mce_external_plugins", array($this, "expCtaTinymcePlugin"));
		add_action("admin_enqueue_scripts",array($this,"expCtaTinymceStyle"));
		add_filter("mce_buttons", array($this, "expCtaAddTinymceButton"));
	}
	
	
	/**
	 * ExpShortCodes:expCtaTinymcePlugin($plugin_array)
	**/
	function expCtaTinymcePlugin($plugin_array){
		$plugin_array["exp_cta"] = EXP_URL . "/assets/tinymce-plugins/exp_cta/exp_cta.js";
		return $plugin_array;
	}
	
	
	/**
	 * ExpShortCodes:expCtaTinymceStyle($hooks)
	**/
	function expCtaTinymceStyle($buttons){
		wp_register_style("exp_cta_style", EXP_URL . "/assets/tinymce-plugins/exp_cta/exp_cta.css",array(),"1.0.1" );
		wp_enqueue_style("exp_cta_style");
	}
	
	
	/**
	 * ExpShortCodes:expCtaAddTinymceButton($buttons)
	**/
	function expCtaAddTinymceButton($buttons){
		array_push($buttons, "exp_cta"); 
		return $buttons;
	}
	
	
	// TODO: LAYOUT FOR `HUMANITARIAN`
	/**
	 * ExpShortCodes:expHumanitarian()
	**/
	function expHumanitarian(){
		add_shortcode("exp_humanitarian", array($this, "expHumanitarianShortcode"));
	}
	
	
	/**
	 * ExpShortCodes:expHumanitarianShortcode($atts, $content, $tag)
	**/
	function expHumanitarianShortcode($atts, $content, $tag){
			// shortcode option/attributes
		$atts = shortcode_atts(
			array(
				"humanitarian" => "1",
				"tag_type" => "p",
				"color" => "#000000",
			), $atts, $tag);
		
		
		// CUSTOM-CODE
$options = get_option("exp_api_settings_setting");
$attribute_humanitarian = $atts["humanitarian"]; 
$attribute_tag_type = $atts["tag_type"]; 
$attribute_color = $atts["color"]; 

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/humanitarian?api_key=".$options['exp_api_key']."&humanitarian=".$attribute_humanitarian."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	echo "<".$attribute_tag_type." style='color: ".$attribute_color.";'>".$response['heading']."</".$attribute_tag_type.">";
}
		
		
		
		return $content;
	}
	
	
	/**
	 * ExpShortCodes:expHumanitarianTinymce()
	**/
	function expHumanitarianTinymce(){
		add_filter("mce_external_plugins", array($this, "expHumanitarianTinymcePlugin"));
		add_action("admin_enqueue_scripts",array($this,"expHumanitarianTinymceStyle"));
		add_filter("mce_buttons", array($this, "expHumanitarianAddTinymceButton"));
	}
	
	
	/**
	 * ExpShortCodes:expHumanitarianTinymcePlugin($plugin_array)
	**/
	function expHumanitarianTinymcePlugin($plugin_array){
		$plugin_array["exp_humanitarian"] = EXP_URL . "/assets/tinymce-plugins/exp_humanitarian/exp_humanitarian.js";
		return $plugin_array;
	}
	
	
	/**
	 * ExpShortCodes:expHumanitarianTinymceStyle($hooks)
	**/
	function expHumanitarianTinymceStyle($buttons){
		wp_register_style("exp_humanitarian_style", EXP_URL . "/assets/tinymce-plugins/exp_humanitarian/exp_humanitarian.css",array(),"1.0.1" );
		wp_enqueue_style("exp_humanitarian_style");
	}
	
	
	/**
	 * ExpShortCodes:expHumanitarianAddTinymceButton($buttons)
	**/
	function expHumanitarianAddTinymceButton($buttons){
		array_push($buttons, "exp_humanitarian"); 
		return $buttons;
	}
	
	
	// TODO: LAYOUT FOR `PATTERNS`
	/**
	 * ExpShortCodes:expPatterns()
	**/
	function expPatterns(){
		add_shortcode("exp_patterns", array($this, "expPatternsShortcode"));
	}
	
	
	/**
	 * ExpShortCodes:expPatternsShortcode($atts, $content, $tag)
	**/
	function expPatternsShortcode($atts, $content, $tag){
			// shortcode option/attributes
		$atts = shortcode_atts(
			array(
				"pattern" => "11",
				"tag_type" => "p",
				"color" => "#000000",
			), $atts, $tag);
		
		
		// CUSTOM-CODE
$options = get_option("exp_api_settings_setting");
$attribute_pattern = $atts["pattern"]; 
$attribute_tag_type = $atts["tag_type"];
$attribute_color = $atts["color"];

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/pattern?api_key=".$options['exp_api_key']."&pattern=".$attribute_pattern."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	echo "<".$attribute_tag_type." style='color: ".$attribute_color.";'>".$response['heading']."</".$attribute_tag_type.">";
}
		
		
		
		return $content;
	}
	
	
	/**
	 * ExpShortCodes:expPatternsTinymce()
	**/
	function expPatternsTinymce(){
		add_filter("mce_external_plugins", array($this, "expPatternsTinymcePlugin"));
		add_action("admin_enqueue_scripts",array($this,"expPatternsTinymceStyle"));
		add_filter("mce_buttons", array($this, "expPatternsAddTinymceButton"));
	}
	
	
	/**
	 * ExpShortCodes:expPatternsTinymcePlugin($plugin_array)
	**/
	function expPatternsTinymcePlugin($plugin_array){
		$plugin_array["exp_patterns"] = EXP_URL . "/assets/tinymce-plugins/exp_patterns/exp_patterns.js";
		return $plugin_array;
	}
	
	
	/**
	 * ExpShortCodes:expPatternsTinymceStyle($hooks)
	**/
	function expPatternsTinymceStyle($buttons){
		wp_register_style("exp_patterns_style", EXP_URL . "/assets/tinymce-plugins/exp_patterns/exp_patterns.css",array(),"1.0.1" );
		wp_enqueue_style("exp_patterns_style");
	}
	
	
	/**
	 * ExpShortCodes:expPatternsAddTinymceButton($buttons)
	**/
	function expPatternsAddTinymceButton($buttons){
		array_push($buttons, "exp_patterns"); 
		return $buttons;
	}
	
	
	// TODO: LAYOUT FOR `QUOTES`
	/**
	 * ExpShortCodes:expQuotes()
	**/
	function expQuotes(){
		add_shortcode("exp_quotes", array($this, "expQuotesShortcode"));
	}
	
	
	/**
	 * ExpShortCodes:expQuotesShortcode($atts, $content, $tag)
	**/
	function expQuotesShortcode($atts, $content, $tag){
			// shortcode option/attributes
		$atts = shortcode_atts(
			array(
				"quote" => "inspirational",
				"tag_type" => "p",
				"color" => "#000000",
			), $atts, $tag);
		
		
		// CUSTOM-CODE
$options = get_option("exp_api_settings_setting");
$attribute_quote = $atts["quote"]; 
$attribute_tag_type = $atts["tag_type"]; 
$attribute_color = $atts["color"]; 

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/quote?api_key=".$options['exp_api_key']."&quote=".$attribute_quote."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	echo "<".$attribute_tag_type." style='color: ".$attribute_color.";'>".$response['heading']."</".$attribute_tag_type.">";
}
		
		
		
		return $content;
	}
	
	
	/**
	 * ExpShortCodes:expQuotesTinymce()
	**/
	function expQuotesTinymce(){
		add_filter("mce_external_plugins", array($this, "expQuotesTinymcePlugin"));
		add_action("admin_enqueue_scripts",array($this,"expQuotesTinymceStyle"));
		add_filter("mce_buttons", array($this, "expQuotesAddTinymceButton"));
	}
	
	
	/**
	 * ExpShortCodes:expQuotesTinymcePlugin($plugin_array)
	**/
	function expQuotesTinymcePlugin($plugin_array){
		$plugin_array["exp_quotes"] = EXP_URL . "/assets/tinymce-plugins/exp_quotes/exp_quotes.js";
		return $plugin_array;
	}
	
	
	/**
	 * ExpShortCodes:expQuotesTinymceStyle($hooks)
	**/
	function expQuotesTinymceStyle($buttons){
		wp_register_style("exp_quotes_style", EXP_URL . "/assets/tinymce-plugins/exp_quotes/exp_quotes.css",array(),"1.0.1" );
		wp_enqueue_style("exp_quotes_style");
	}
	
	
	/**
	 * ExpShortCodes:expQuotesAddTinymceButton($buttons)
	**/
	function expQuotesAddTinymceButton($buttons){
		array_push($buttons, "exp_quotes"); 
		return $buttons;
	}
	
	
	// TODO: LAYOUT FOR `TIMES`
	/**
	 * ExpShortCodes:expTimes()
	**/
	function expTimes(){
		add_shortcode("exp_times", array($this, "expTimesShortcode"));
	}
	
	
	/**
	 * ExpShortCodes:expTimesShortcode($atts, $content, $tag)
	**/
	function expTimesShortcode($atts, $content, $tag){
			// shortcode option/attributes
		$atts = shortcode_atts(
			array(
				"time" => "1",
				"tag_type" => "p",
				"color" => "#000000",
			), $atts, $tag);
		
		
		// CUSTOM-CODE
$options = get_option("exp_api_settings_setting");
$attribute_time = $atts["time"]; 
$attribute_tag_type = $atts["tag_type"]; 
$attribute_color = $atts["color"]; 
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://api.everxp.com/heading/time?api_key=".$options['exp_api_key']."&time=".$attribute_time."&lang=en");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

$response = json_decode($response, true);
if (!array_key_exists("heading",$response)) {
	var_dump($response);
} else {
	echo "<".$attribute_tag_type." style='color: ".$attribute_color.";'>".$response['heading']."</".$attribute_tag_type.">";
}
		
		
		
		return $content;
	}
	
	
	/**
	 * ExpShortCodes:expTimesTinymce()
	**/
	function expTimesTinymce(){
		add_filter("mce_external_plugins", array($this, "expTimesTinymcePlugin"));
		add_action("admin_enqueue_scripts",array($this,"expTimesTinymceStyle"));
		add_filter("mce_buttons", array($this, "expTimesAddTinymceButton"));
	}
	
	
	/**
	 * ExpShortCodes:expTimesTinymcePlugin($plugin_array)
	**/
	function expTimesTinymcePlugin($plugin_array){
		$plugin_array["exp_times"] = EXP_URL . "/assets/tinymce-plugins/exp_times/exp_times.js";
		return $plugin_array;
	}
	
	
	/**
	 * ExpShortCodes:expTimesTinymceStyle($hooks)
	**/
	function expTimesTinymceStyle($buttons){
		wp_register_style("exp_times_style", EXP_URL . "/assets/tinymce-plugins/exp_times/exp_times.css",array(),"1.0.1" );
		wp_enqueue_style("exp_times_style");
	}
	
	
	/**
	 * ExpShortCodes:expTimesAddTinymceButton($buttons)
	**/
	function expTimesAddTinymceButton($buttons){
		array_push($buttons, "exp_times"); 
		return $buttons;
	}
	
	
}
//EOF
